#include <iostream>
using namespace std;

int sequentialModeFinder(int* A, int n);
int recursiveModeFinder(int* A, int start, int end);
int fastIterativeModeFinder(int* A, int start, int end);

void main(){
	int A[] = {1,2,4,7,11,10,8,4,-9};
	int n = sizeof(A)/sizeof(int); //array size;
	cout << "The answer of the sequential mode finder is : " << sequentialModeFinder(A,n) << endl;
	cout << "The answer of the recursive mode finder is : " << recursiveModeFinder(A,0,n-1) << endl;
	cout << "The answer of the fast iterative mode finder is : " << recursiveModeFinder(A,0,n-1) << endl;

}

int sequentialModeFinder(int *A,int n){	
	for(int i=0;i<n-1;i++){
		if(A[i]>A[i+1]) return i;
	}
	return n-1;
}

int recursiveModeFinder(int *A, int start, int end){
	if((end==start) || (end==start+1)){
		if(A[start]<A[end])	return end;
		else return start;
	}
	int mid = (start + end)/2;
	if(A[mid]>A[mid+1]) //mid is either the mode or is already past the mode
		return recursiveModeFinder(A,start,mid);
	else //We did not reach the mode yet
		return recursiveModeFinder(A,mid,end);
	
}

int fastIterativeModeFinder(int* A, int start, int end){
	while((start!=end)&&(start+1!=end)){
		int mid = (start+end)/2;
		if(A[mid]>A[mid+1]) end = mid;
		else start = mid;
	}
	if(A[start]>A[end]) return start;
	else return end;
}
