#include<iostream>
using namespace std;


double power(int x, int y);
double smartPower(int x, int y);

void main(){
	cout << power(2,10) << endl;
	cout << smartPower(2,10) << endl;
	cout << power(10,-5) << endl ;
	cout << smartPower(10,-5) << endl;
}
//for simplicity we do not check for the case where x = 0 and y = 0;
double power(int x, int y){
	if(y<0) return 1/power(x,-y);
	else if (y==0) return 1;
	else return x*power(x,y-1);
}
double smartPower(int x, int y){
	if(y<0) return 1/power(x,-y);
	else if(y==0) return 1;
	else {
		double val = power(x,y/2) ;		
		if(y%2==1) return val * val * x;
		else return val * val;		
	}
	
}
//the recurrence is:
//u(y) = u(y/2)^2               if y is even and > 0 
//u(y) = u(floor(y/2))^2  * x   if y is odd and > 0 
//u(y) = x                      if y=0
//u(y) = 1/u(-y)                if y<0